module.exports = function startDevServer (config) {
  const opn = require('opn')
  const { findAvailablePort } = require('./utils/port')

  return findAvailablePort(process.env.PORT || 3000)
    .then(port => {
      console.log('[ nuxt ] dev server starts.')
      nuxtServe(config, port)
      opn(`http://127.0.0.1:${port}`)
    })
}

/**
 * start an development server
 * with hot reloading
 */
function nuxtServe (config, port) {
  const Nuxt = require('nuxt')
  const Express = require('express')

  const app = Express()
  const nuxt = new Nuxt(config)

  config.dev = !(process.env.NODE_ENV === 'production')

  // Build only in dev mode with hot-reloading
  if (config.dev) {
    nuxt.build()
  }

  app.use(nuxt.render)
  app.listen(port, '127.0.0.1')
  console.log(`[ nuxt ] server listening on localhost:${port}.`)
  console.log(`[ nuxt ] compiling... please wait...`)
}
