const portscanner = require('portscanner')

exports.findAvailablePort = function findAvailablePort (port) {
  const ports = [port, port + 1, port + 2]
  return findAPortNotInUse(ports)
    .catch(() => findAvailablePort(port + 3))
}

function findAPortNotInUse (ports) {
  return new Promise((resolve, reject) => {
    portscanner.findAPortNotInUse(ports, '127.0.0.1', (err, port) => {
      if (err) {
        reject(err)
      } else if (port === false) {
        reject(new Error(`${ports} are all in use...`))
      } else {
        resolve(port)
      }
    })
  })
}
